// CREDIT: Automatically converted from https://www.github.com/gl-transitions/gl-transitions/tree/master/circleopen.glsl
// ISADORA_FLOAT_PARAM(progress, zQT\, 0, 1, 0, "No help available.")
// ISADORA_FLOAT_PARAM(smoothness, s>84, 0, 1, 0.3, "No help available.")
// ISADORA_INT_PARAM_ONOFF(opening, nhJ1, 0, "No help available.")


uniform sampler2D tex0;
uniform sampler2D tex1;
uniform float progress;
uniform float smoothness;
uniform bool opening;



vec4 getFromColor(vec2 inUV)	{
	return texture2D(tex0, inUV);
}
vec4 getToColor(vec2 inUV)	{
	return texture2D(tex1, inUV);
}



// author: gre
// License: MIT

const vec2 center = vec2(0.5, 0.5);
const float SQRT_2 = 1.414213562373;

vec4 transition (vec2 uv) {
  float x = opening ? progress : 1.-progress;
  float m = smoothstep(-smoothness, 0.0, SQRT_2*distance(center, uv) - x*(1.+smoothness));
  return mix(getFromColor(uv), getToColor(uv), opening ? 1.-m : m);
}



void main()	{
	gl_FragColor = transition(gl_TexCoord[0].xy);
}
